'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TestRecorder = undefined;

var _testRecorder = require('./test-recorder');

var _testRecorder2 = _interopRequireDefault(_testRecorder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var reduxRecord = function reduxRecord(_ref) {
  var reducer = _ref.reducer;
  var _ref$includeReducer = _ref.includeReducer;
  var includeReducer = _ref$includeReducer === undefined ? true : _ref$includeReducer;
  var stateKey = _ref.stateKey;
  var actionSubset = _ref.actionSubset;
  var _ref$equality = _ref.equality;
  var equality = _ref$equality === undefined ? function (result, nextState) {
    return result === nextState;
  } : _ref$equality;

  var initState = undefined;
  var actions = [];
  var recording = false;
  var showingTest = false;
  var stringifiedReducer = '/* IMPORT YOUR REDUCER HERE */';
  if (includeReducer) {
    stringifiedReducer = 'var reducer = ' + reducer.toString();
  }
  var equalityFunction = equality.toString();
  var startRecord = function startRecord() {
    return recording = true;
  };
  var stopRecord = function stopRecord() {
    recording = false;
    showingTest = true;
  };
  var getRecordingStatus = function getRecordingStatus() {
    return recording;
  };
  var shouldShowTest = function shouldShowTest() {
    return showingTest;
  };
  var hideTest = function hideTest() {
    actions = [];
    showingTest = false;
    initState = undefined;
  };
  var getTest = function getTest() {
    /* make my template string look ugly af here so the returned code has basically proper spacing
     * TODO - look into if there is a better way to do this 
    */
    return 'var test = require(\'tape\');\nvar state = ' + initState + ';\n' + stringifiedReducer + '\nvar equality = ' + equalityFunction + ';\ntest(\'expected state returned for each action\', function(assert) {\n  var actions = ' + JSON.stringify(actions, 4) + ';\n  var returnExpectedState = actions.map(function (action) {\n    var result = reducer(state, action.action);\n    state = result;\n    return equality(result, action.nextState);\n  });\n  assert.ok(returnExpectedState.every(function(expected) { return expected }), \'expected state returned for each action\');\n  assert.end();\n});';
  };
  var middleware = function middleware(_ref2) {
    var getState = _ref2.getState;
    return function (next) {
      return function (action) {
        if (initState === undefined) {
          initState = stateKey ? getState()[stateKey] : getState();
        }
        next(action);
        if (recording) {
          var nextState = stateKey ? getState()[stateKey] : getState();
          if (!actionSubset || actionSubset[action.type]) {
            actions.push({ action: action, nextState: nextState });
          }
        }
      };
    };
  };
  var props = { getRecordingStatus: getRecordingStatus, startRecord: startRecord, stopRecord: stopRecord, getTest: getTest, shouldShowTest: shouldShowTest, hideTest: hideTest };
  return { middleware: middleware, props: props };
};
exports.TestRecorder = _testRecorder2.default;
exports.default = reduxRecord;